﻿using JetBrains.Annotations;
using OpcLabs.BaseLib.Execution;
using OpcLabs.BaseLib.LiveBinding;

namespace OpcLabs.BaseLibFactory.LiveBinding
{
    static public class PointBinderInstances
    {
        [NotNull]
        static public PointBinder Instance0 => new PointBinder();

        [NotNull]
        static public PointBinder Instance1
        {
            get
            {
                var pointBinder = new PointBinder
                {
                    DesignFastestUpdateRate = 111111,
                    QueuedExecution = true,
                };
                return pointBinder;
            }
        }

        [NotNull]
        static public PointBinder Instance2
        {
            get
            {
                var pointBinder = new PointBinder
                {
                    DesignFastestUpdateRate = 111111,
                    QueuedExecution = true,
                };
                Reflected.PropertiesAssign(pointBinder.DefaultBindingGroup, PointBindingGroupInstances.Instance1);
                return pointBinder;
            }
        }

        // IMPROVE: does not serialize to XAML
        //[NotNull]
        //static public PointBinder Instance3
        //{
        //    get
        //    {
        //        var pointBinder = new PointBinder
        //        {
        //            DesignFastestUpdateRate = 111111,
        //            QueuedExecution = true,
        //        };
        //        Reflected.Assign(pointBinder.DefaultBindingGroup, PointBindingGroupInstances.Instance1);
        //        return pointBinder;
        //    }
        //}

        // IMPROVE: does not serialize to XAML
        //[NotNull]
        //static public PointBinder Instance4
        //{
        //    get
        //    {
        //        var pointBinder = new PointBinder
        //        {
        //            DesignFastestUpdateRate = 111111,
        //            QueuedExecution = true,
        //        };
        //        Reflected.Assign(pointBinder.DefaultBindingGroup, PointBindingGroupInstances.Instance1);
        //        pointBinder.BindingGroups.Add(PointBindingGroupInstances.Instance0);
        //        pointBinder.BindingGroups.Add(PointBindingGroupInstances.Instance1);
        //        return pointBinder;
        //    }
        //}
    }
}
