﻿using JetBrains.Annotations;
using OpcLabs.BaseLib;

namespace OpcLabs.BaseLibFactory
{
    static public class ResourceDescriptorInstances
    {
        // Instance0 is the same as Null
        //[NotNull]
        //static public ResourceDescriptor Instance0 => new ResourceDescriptor();

        [NotNull]
        static public ResourceDescriptor Instance1 => new ResourceDescriptor("testUrlString");

        [NotNull]
        static public ResourceDescriptor InvalidFormat = new ResourceDescriptor { UrlString = "!@#$%^&*()" };

        // From http://www.freeformatter.com/url-parser-query-string-splitter.html :

        [NotNull]
        static public ResourceDescriptor RfcUri1 => new ResourceDescriptor("ftp://ftp.is.co.za/rfc/rfc1808.txt");

        [NotNull]
        static public ResourceDescriptor RfcUri2 => new ResourceDescriptor("http://www.ietf.org/rfc/rfc2396.txt");

        [NotNull]
        static public ResourceDescriptor RfcUri3 => new ResourceDescriptor("ldap://[2001:db8::7]/c=GB?objectClass?one");

        [NotNull]
        static public ResourceDescriptor RfcUri4 => new ResourceDescriptor("news:comp.infosystems.www.servers.unix");

        [NotNull]
        static public ResourceDescriptor RfcUri5 => new ResourceDescriptor("tel:+1-816-555-1212");

        [NotNull]
        static public ResourceDescriptor RfcUri6 => new ResourceDescriptor("telnet://192.0.2.16:80/");

        [NotNull]
        static public ResourceDescriptor RfcUri7 => new ResourceDescriptor("urn:oasis:names:specification:docbook:dtd:xml:4.1.2");

        [NotNull]
        static public ResourceDescriptor Url1 => new ResourceDescriptor("http://www.google.com");

        [NotNull]
        static public ResourceDescriptor Url2 => new ResourceDescriptor("http://foo:bar@w1.superman.com/very/long/path.html?p1=v1&p2=v2#more-details");

        [NotNull]
        static public ResourceDescriptor Url3 => new ResourceDescriptor("https://secured.com:443");

        [NotNull]
        static public ResourceDescriptor WikipediaUrn1 => new ResourceDescriptor("urn:isbn:0451450523");

        [NotNull]
        static public ResourceDescriptor WikipediaUrn2 => new ResourceDescriptor("urn:ietf:rfc:2648");

        [NotNull]
        static public ResourceDescriptor WikipediaUrn3 => new ResourceDescriptor("urn:uuid:6e8bc430-9c3a-11d9-9669-0800200c9a66");

        //...

        //
    }
}
