﻿using System;
using System.ComponentModel;
using System.Windows.Forms;
using OpcLabs.BaseLib.ComponentModel.Referencing;
using OpcLabs.BaseLib.Forms.Common;

namespace OpcLabs.BaseLibFormsTestApp
{
    public partial class MemberNameEditorTestForm : Form
    {
        public MemberNameEditorTestForm()
        {
            InitializeComponent();

            //_memberNameEditorTestClass.TargetComponent = textBox1;
            _memberNameEditorTestClass.ExtenderProvider = _myExtender;
            
            //_memberNameEditorTestClass.TargetComponent = this;
            _memberNameEditorTestClass.TargetComponent = _myForm;
            propertyGrid1.SelectedObject = _memberNameEditorTestClass;
//            propertyGrid1.SelectedObject = _myForm;
           
        }

        private readonly MyExtender _myExtender = new MyExtender();

        private readonly ValueTarget _memberNameEditorTestClass = new ValueTarget();

        //public class MemberNameEditorTestClass : ValueTarget
        //{
            
        //}

        private readonly MyForm _myForm = new MyForm();
        

        //[DefaultMember("Text")]
        public class MyForm : Form
        {
            public MyForm() : base()
            {
                
            }

            public MyForm(String name) : base()
            {
                
            }

            static MyForm()
            {
                StaticText = "static";
            }

            /// <inheritdoc cref="object.ToString()"/>
            //[Description("Description MyForm.ToString()")]
            public override string ToString()
            {
                return base.ToString();
            }

            [Description("Description MyForm.ToString(bool)")]
            public string ToString(bool withParameters)
            {
                return "P";
            }
            
            [Obsolete]
            public bool ObsoleteMethod(bool parmaeters)
            {
                return true;
            }

            [Description("Test parameters.")]
            public void Test3(String inPrm, out int outPrm, ref int refPrm)
            {
                outPrm = 0;
            }

            [Description("Test parameters.")]
            public void TestOut(out int outPrm)
            {
                outPrm = 0;
            }
            [Description("Test parameters.")]
            public void TestRef(ref int refPrm)
            {
            }

            [Description("Test parameters.")]
            public void TestOptional2(String inPrm, int index = 5)
            {
            }

            [Description("Test parameters.")]
            public void TestOptional1(int index = 5)
            {
            }

            [Description("Test very long name.")]
            public void TestVeryLongVeryLongVeryLongVeryLongVeryLongVeryLongVeryLong(String longText)
            {
            }

            static public String StaticMethod()
            {
                return StaticText;
            }

            static private String StaticText;

            static public int StaticProperty { get; set; }

            static public Double StaticField = 1.0;

        }

        [ProvideProperty("ExtendInt", typeof(Object))]
        [ProvideProperty("ExtendString", typeof(Object))]
        public class MyExtender : IExtenderProvider
        {
            public bool CanExtend(object extendee)
            {
                if (extendee is Form) return true;
                if (extendee is TextBox) return true;
                return false;
            }

            //[Description("20131218 test")]
            //[Category("20131218")]
            public void SetExtendInt(object extedee, int i)
            {
            }

            public double GetExtendInt(double d)
            {
                return 0.0;
            }

            [Category("Data")]
            [Description("Gets extend string.")]
            [Obsolete]
            public String GetExtendString(object extedee)
            {
                return "";
            }

            [Description("Sets extend string.")]
            public void SetExtendString(object extedee, String s)
            {
                
            }
            [Obsolete]
            public void SetExtendString(object extedee, Char c)
            {
                
            }
            public void GetExtendeeString(object extedee)
            {
                
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            var members = typeof (MyForm).GetMembers();
            
            memberInput1.Members = members;
            switch (memberInfoProviderComboBox.SelectedIndex)
            {
                default:
                    memberPathInput1.MemberInfoProvider = null;
                    break;
                case 1:
                    memberPathInput1.MemberInfoProvider = new AllMemberInfoProvider();
                    break;
                case 2:
                    memberPathInput1.MemberInfoProvider = new AllMemberInfoProvider();
                    break;
            }
            memberPathInput1.Members = members;
        }
    }
}
