﻿
using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.DataTypeModel;
using OpcLabs.BaseLib.Portable;

namespace OpcLabs.BaseLibTest.DataTypeModel
{
    public partial class SequenceDataTest
    {
        [TestMethod]
        public void TryValidateTest_LengthMismatch()
        {
            var target = new SequenceData(new SequenceDataType(3, new PrimitiveDataType()))
            {
                new PrimitiveData(101),
                new PrimitiveData(102)
            };
            Exception exception = target.TryValidate();
            Assert.IsNotNull(exception);
            Assert.IsInstanceOfType(exception, typeof(CustomException));
            Assert.AreEqual("The sequence data contain 2 elements, but the data type \"sequence[3] of \" specifies a fixed length of 3.", exception.Message);
        }

        [TestMethod]
        public void TryValidateTest_LengthMismatch_Inverse()
        {
            var target = new SequenceData(new SequenceDataType(3, new PrimitiveDataType()))
            {
                new PrimitiveData(101),
                new PrimitiveData(102),
                new PrimitiveData(103)
            };
            Exception exception = target.TryValidate();
            Assert.IsNull(exception);
        }
    }
}
