﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using JetBrains.Annotations;
using OpcLabs.BaseLib.ComInterop;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.DataAccess.AddressSpace;

namespace OpcLabs.EasyOpcLiveTest.DataAccess.Environment
{
    // ReSharper disable once InconsistentNaming
    public class OpcLabs_KitServer : CommonServer
    {
        #region Public Constants

        public const string ClsidString = "{C8A12F17-1E03-401E-B53D-6C654DD576DA}";

        public const string ProgId = "OPCLabs.KitServer.2";

        public const string VersionIndependentProgId = "OPCLabs.KitServer";

        #endregion



        #region Public Types

        static public class BrowsePaths
        {
            // ReSharper disable InconsistentNaming
            public const string Constant_BOOL = "/Simulation/Constant_BOOL";
            public const string Constant_I4 = "/Simulation/Constant_I4";
            public const string Incrementing_1s = "/Simulation/Incrementing (1 s)";
            public const string Register_BOOL = "/Simulation/Register_BOOL";
            public const string Register_I4 = "/Simulation/Register_I4";
            public const string UnknownBrowsePath = "/Simulation/UnknownBrowseName1/UnknownBrowseName2";
            // ReSharper restore InconsistentNaming
        }

        static public class ItemIds
        {
            // ReSharper disable InconsistentNaming
            public const string Command = "ServerControl.Command";
            //public const string Constant_ArrayOfI2 = "Simulation.Constant_ArrayOfI2";
            //public const string Constant_ArrayOfR4 = "Simulation.Constant_ArrayOfR4";
            //public const string Constant_ArrayOfR8 = "Simulation.Constant_ArrayOfR8";
            public const string Constant_BOOL = "Simulation.Constant_BOOL";
            public const string Constant_BSTR = "Simulation.Constant_BSTR";
            public const string Constant_I1 = "Simulation.Constant_I1";
            public const string Constant_I2 = "Simulation.Constant_I2";
            public const string Constant_I4 = "Simulation.Constant_I4";
            public const string Constant_R4 = "Simulation.Constant_R4";
            public const string Constant_R8 = "Simulation.Constant_R8";
            public const string Constant_UI1 = "Simulation.Constant_UI1";
            public const string Constant_UI2 = "Simulation.Constant_UI2";
            public const string Constant_UI4 = "Simulation.Constant_UI4";
            public const string Incrementing_1s = "Simulation.Incrementing (1 s)";
            public const string Random = "Simulation.Random";
            public const string Ramp_1s = "Simulation.Ramp (1 s)";
            public const string Register_ArrayOfI2 = "Simulation.Register_ArrayOfI2";
            public const string Register_ArrayOfR4 = "Simulation.Register_ArrayOfR4";
            public const string Register_ArrayOfR8 = "Simulation.Register_ArrayOfR8";
            public const string Register_BOOL = "Simulation.Register_BOOL";
            public const string Register_BSTR = "Simulation.Register_BSTR";
            public const string Register_I1 = "Simulation.Register_I1";
            public const string Register_I2 = "Simulation.Register_I2";
            public const string Register_I4 = "Simulation.Register_I4";
            public const string Register_R4 = "Simulation.Register_R4";
            public const string Register_R8 = "Simulation.Register_R8";
            public const string Register_UI1 = "Simulation.Register_UI1";
            public const string Register_UI2 = "Simulation.Register_UI2";
            public const string Register_UI4 = "Simulation.Register_UI4";
            public const string UnknownItem = "UnknownItem";
            // ReSharper restore InconsistentNaming
        }

        public class ServerDescriptorsInfo
        {
            public ServerDescriptorsInfo([NotNull] OpcLabs_KitServer parent)
            {
                _parent = parent;
            }

            [NotNull]
            public ServerDescriptor WithClsId => new ServerDescriptor(_parent.Location, Guid.Parse(ClsidString));

            [NotNull]
            public ServerDescriptor WithProgId => new ServerDescriptor(_parent.Location, ProgId);

            [NotNull]
            public ServerDescriptor WithVersionIndependentProgId => new ServerDescriptor(_parent.Location, VersionIndependentProgId);

            [NotNull]
            private readonly OpcLabs_KitServer _parent;
        }

        #endregion



        #region Public Constructors

        public OpcLabs_KitServer([NotNull] string location)
            : base(location)
        {
            ServerDescriptors = new ServerDescriptorsInfo(this);
        }

        #endregion



        #region Static Public Properties

        [NotNull]
        static public IEnumerable<DAItemCatalogEntry> AllItemCatalogEntries
        {
            get
            {
                // / Simulation/Constant_*

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Constant_BOOL",
                    browsePath: "/Simulation/Constant_BOOL",
                    nodePath: null,
                    itemId: "Simulation.Constant_BOOL",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Readable,
                    BehaviorKind = OpcItemBehaviorKind.Constant,
                    DataType = VarTypes.Bool,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = false,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    // ReSharper disable StringLiteralTypo
                    name: "Constant_BSTR",
                    browsePath: "/Simulation/Constant_BSTR",
                    nodePath: null,
                    itemId: "Simulation.Constant_BSTR",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                    // ReSharper restore StringLiteralTypo
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Readable,
                    BehaviorKind = OpcItemBehaviorKind.Constant,
                    DataType = VarTypes.BStr,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = "",
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Constant_CY",
                    browsePath: "/Simulation/Constant_CY",
                    nodePath: null,
                    itemId: "Simulation.Constant_CY",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Readable,
                    BehaviorKind = OpcItemBehaviorKind.Constant,
                    DataType = VarTypes.Cy,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = (Decimal)0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Constant_DATE",
                    browsePath: "/Simulation/Constant_DATE",
                    nodePath: null,
                    itemId: "Simulation.Constant_DATE",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Readable,
                    BehaviorKind = OpcItemBehaviorKind.Constant,
                    DataType = VarTypes.Date,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = new DateTime(1899, 12, 30),
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Constant_DECIMAL",
                    browsePath: "/Simulation/Constant_DECIMAL",
                    nodePath: null,
                    itemId: "Simulation.Constant_DECIMAL",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Readable,
                    BehaviorKind = OpcItemBehaviorKind.Constant,
                    DataType = VarTypes.Decimal,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = (Decimal)0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Constant_EMPTY",
                    browsePath: "/Simulation/Constant_EMPTY",
                    nodePath: null,
                    itemId: "Simulation.Constant_EMPTY",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Readable,
                    BehaviorKind = OpcItemBehaviorKind.Constant,
                    DataType = VarTypes.Empty,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = null,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Constant_I1",
                    browsePath: "/Simulation/Constant_I1",
                    nodePath: null,
                    itemId: "Simulation.Constant_I1",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Readable,
                    BehaviorKind = OpcItemBehaviorKind.Constant,
                    DataType = VarTypes.I1,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = (short)0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Constant_I2",
                    browsePath: "/Simulation/Constant_I2",
                    nodePath: null,
                    itemId: "Simulation.Constant_I2",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Readable,
                    BehaviorKind = OpcItemBehaviorKind.Constant,
                    DataType = VarTypes.I2,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = (short)0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Constant_I4",
                    browsePath: "/Simulation/Constant_I4",
                    nodePath: null,
                    itemId: "Simulation.Constant_I4",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Readable,
                    BehaviorKind = OpcItemBehaviorKind.Constant,
                    DataType = VarTypes.I4,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = 0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Constant_R4",
                    browsePath: "/Simulation/Constant_R4",
                    nodePath: null,
                    itemId: "Simulation.Constant_R4",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Readable,
                    BehaviorKind = OpcItemBehaviorKind.Constant,
                    DataType = VarTypes.R4,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = 0.0f,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Constant_R8",
                    browsePath: "/Simulation/Constant_R8",
                    nodePath: null,
                    itemId: "Simulation.Constant_R8",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Readable,
                    BehaviorKind = OpcItemBehaviorKind.Constant,
                    DataType = VarTypes.R8,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = 0.0d,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Constant_UI1",
                    browsePath: "/Simulation/Constant_UI1",
                    nodePath: null,
                    itemId: "Simulation.Constant_UI1",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Readable,
                    BehaviorKind = OpcItemBehaviorKind.Constant,
                    DataType = VarTypes.UI1,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = (byte)0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Constant_UI2",
                    browsePath: "/Simulation/Constant_UI2",
                    nodePath: null,
                    itemId: "Simulation.Constant_UI2",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Readable,
                    BehaviorKind = OpcItemBehaviorKind.Constant,
                    DataType = VarTypes.UI2,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = 0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Constant_UI4",
                    browsePath: "/Simulation/Constant_UI4",
                    nodePath: null,
                    itemId: "Simulation.Constant_UI4",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Readable,
                    BehaviorKind = OpcItemBehaviorKind.Constant,
                    DataType = VarTypes.UI4,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = (long)0,
                };

                // / Simulation/Register_*

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_ArrayOfBOOL",
                    browsePath: "/Simulation/Register_ArrayOfBOOL",
                    nodePath: null,
                    itemId: "Simulation.Register_ArrayOfBOOL",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.ArrayOfBool,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = false,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    // ReSharper disable StringLiteralTypo
                    name: "Register_ArrayOfBSTR",
                    browsePath: "/Simulation/Register_ArrayOfBSTR",
                    nodePath: null,
                    itemId: "Simulation.Register_ArrayOfBSTR",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                // ReSharper restore StringLiteralTypo
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.ArrayOfBStr,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = "",
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_ArrayOfCY",
                    browsePath: "/Simulation/Register_ArrayOfCY",
                    nodePath: null,
                    itemId: "Simulation.Register_ArrayOfCY",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.ArrayOfCy,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = (Decimal)0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_ArrayOfDATE",
                    browsePath: "/Simulation/Register_ArrayOfDATE",
                    nodePath: null,
                    itemId: "Simulation.Register_ArrayOfDATE",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.ArrayOfDate,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = new DateTime(1899, 12, 30),
                };

                // SAFEARRAYs of VT_DECIMAL don't work but it may not be our fault
                //yield return new DAItemCatalogEntry(new DANodeElement(
                //    name: "Register_ArrayOfDECIMAL",
                //    browsePath: "/Simulation/Register_ArrayOfDECIMAL",
                //    nodePath: null,
                //    itemId: "Simulation.Register_ArrayOfDECIMAL",
                //    isBranch: false,
                //    isLeaf: true,
                //    hasChildren: false))
                //{
                //    PropertyCatalog = CommonPropertyCatalogEntries,
                //    AccessRights = DAAccessRights.Both,
                //    BehaviorKind = OpcItemBehaviorKind.Register,
                //    DataType = VarTypes.ArrayOfDecimal,
                //    FastestRateOfChange = Timeout.Infinite,
                //    Quality = DAQualities.GoodNonspecific,
                //    SlowestRateOfChange = Timeout.Infinite,
                //    Value = (Decimal)0,
                //};

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_ArrayOfI1",
                    browsePath: "/Simulation/Register_ArrayOfI1",
                    nodePath: null,
                    itemId: "Simulation.Register_ArrayOfI1",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.ArrayOfI1,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = (short)0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_ArrayOfI2",
                    browsePath: "/Simulation/Register_ArrayOfI2",
                    nodePath: null,
                    itemId: "Simulation.Register_ArrayOfI2",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.ArrayOfI2,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = (short)0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_ArrayOfI4",
                    browsePath: "/Simulation/Register_ArrayOfI4",
                    nodePath: null,
                    itemId: "Simulation.Register_ArrayOfI4",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.ArrayOfI4,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = 0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_ArrayOfR4",
                    browsePath: "/Simulation/Register_ArrayOfR4",
                    nodePath: null,
                    itemId: "Simulation.Register_ArrayOfR4",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.ArrayOfR4,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = 0.0f,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_ArrayOfR8",
                    browsePath: "/Simulation/Register_ArrayOfR8",
                    nodePath: null,
                    itemId: "Simulation.Register_ArrayOfR8",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.ArrayOfR8,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = 0.0d,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_ArrayOfUI1",
                    browsePath: "/Simulation/Register_ArrayOfUI1",
                    nodePath: null,
                    itemId: "Simulation.Register_ArrayOfUI1",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.ArrayOfUI1,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = (byte)0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_ArrayOfUI2",
                    browsePath: "/Simulation/Register_ArrayOfUI2",
                    nodePath: null,
                    itemId: "Simulation.Register_ArrayOfUI2",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.ArrayOfUI2,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = 0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_ArrayOfUI4",
                    browsePath: "/Simulation/Register_ArrayOfUI4",
                    nodePath: null,
                    itemId: "Simulation.Register_ArrayOfUI4",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.ArrayOfUI4,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = (long)0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_BOOL",
                    browsePath: "/Simulation/Register_BOOL",
                    nodePath: null,
                    itemId: "Simulation.Register_BOOL",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.Bool,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = false,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    // ReSharper disable StringLiteralTypo
                    name: "Register_BSTR",
                    browsePath: "/Simulation/Register_BSTR",
                    nodePath: null,
                    itemId: "Simulation.Register_BSTR",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                    // ReSharper restore StringLiteralTypo
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.BStr,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = "",
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_CY",
                    browsePath: "/Simulation/Register_CY",
                    nodePath: null,
                    itemId: "Simulation.Register_CY",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.Cy,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = (Decimal)0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_DATE",
                    browsePath: "/Simulation/Register_DATE",
                    nodePath: null,
                    itemId: "Simulation.Register_DATE",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.Date,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = new DateTime(1899, 12, 30),
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_DECIMAL",
                    browsePath: "/Simulation/Register_DECIMAL",
                    nodePath: null,
                    itemId: "Simulation.Register_DECIMAL",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.Decimal,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = (Decimal)0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_EMPTY",
                    browsePath: "/Simulation/Register_EMPTY",
                    nodePath: null,
                    itemId: "Simulation.Register_EMPTY",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.Empty,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = null,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_I1",
                    browsePath: "/Simulation/Register_I1",
                    nodePath: null,
                    itemId: "Simulation.Register_I1",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.I1,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = (short)0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_I2",
                    browsePath: "/Simulation/Register_I2",
                    nodePath: null,
                    itemId: "Simulation.Register_I2",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.I2,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = (short)0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_I4",
                    browsePath: "/Simulation/Register_I4",
                    nodePath: null,
                    itemId: "Simulation.Register_I4",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.I4,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = 0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_R4",
                    browsePath: "/Simulation/Register_R4",
                    nodePath: null,
                    itemId: "Simulation.Register_R4",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.R4,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = 0.0f,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_R8",
                    browsePath: "/Simulation/Register_R8",
                    nodePath: null,
                    itemId: "Simulation.Register_R8",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.R8,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = 0.0d,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_UI1",
                    browsePath: "/Simulation/Register_UI1",
                    nodePath: null,
                    itemId: "Simulation.Register_UI1",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.UI1,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = (byte)0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_UI2",
                    browsePath: "/Simulation/Register_UI2",
                    nodePath: null,
                    itemId: "Simulation.Register_UI2",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.UI2,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = 0,
                };

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Register_UI4",
                    browsePath: "/Simulation/Register_UI4",
                    nodePath: null,
                    itemId: "Simulation.Register_UI4",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Both,
                    BehaviorKind = OpcItemBehaviorKind.Register,
                    DataType = VarTypes.UI4,
                    FastestRateOfChange = Timeout.Infinite,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = Timeout.Infinite,
                    Value = (long)0,
                };

                // ...

                yield return new DAItemCatalogEntry(new DANodeElement(
                    name: "Random (1 s)",
                    browsePath: "/Simulation/Random (1 s)",
                    nodePath: null,
                    itemId: "Simulation.Random (1 s)",
                    isBranch: false,
                    isLeaf: true,
                    hasChildren: false))
                {
                    PropertyCatalog = CommonPropertyCatalogEntries,
                    AccessRights = DAAccessRights.Readable,
                    BehaviorKind = OpcItemBehaviorKind.Unknown,
                    DataType = VarTypes.R8,
                    FastestRateOfChange = 0,
                    Quality = DAQualities.GoodNonspecific,
                    SlowestRateOfChange = 0,
                };


                // TODO: need some write-only item
                // TODO: many others...
            }
        }

        [NotNull]
        static public IEnumerable<DAItemCatalogEntry[]> AllItemCatalogEntryDataRows => AllItemCatalogEntries.Select(entry => new[] { entry });

        [NotNull]
        static public IEnumerable<DAPropertyCatalogEntry[]> CommonPropertyCatalogEntryDataRows => CommonPropertyCatalogEntries.Select(entry => new[] { entry });

        [NotNull]
        static public IEnumerable<DAItemCatalogEntry[]> NonReadableItemCatalogEntryDataRows => AllItemCatalogEntries.NonReadables().Select(entry => new[] { entry });

        [NotNull]
        static public IEnumerable<DAItemCatalogEntry[]> ReadableItemCatalogEntryDataRows => AllItemCatalogEntries.Readables().Select(entry => new[] { entry });

        [NotNull]
        static public IEnumerable<DAItemCatalogEntry[]> ReadWriteableItemCatalogEntryDataRows => AllItemCatalogEntries.ReadWriteables().Select(entry => new[] { entry });

        #endregion



        #region Static Private Properties

        [NotNull]
        static private IEnumerable<DAPropertyCatalogEntry> CommonPropertyCatalogEntries
        {
            get
            {
                yield return new DAPropertyCatalogEntry(new DAPropertyElement(DAPropertyIds.DataType,
                    VarTypes.I2, "Item Canonical Data Type"));
                yield return new DAPropertyCatalogEntry(new DAPropertyElement(DAPropertyIds.Value,
                    VarTypes.Empty, "Item Value"));
                yield return new DAPropertyCatalogEntry(new DAPropertyElement(DAPropertyIds.Quality,
                    VarTypes.I2, "Item Quality"));
                yield return new DAPropertyCatalogEntry(new DAPropertyElement(DAPropertyIds.Timestamp,
                    VarTypes.Date, "Item Timestamp"));
                yield return new DAPropertyCatalogEntry(new DAPropertyElement(DAPropertyIds.AccessRights,
                    VarTypes.I4, "Item Access Rights"));
                yield return new DAPropertyCatalogEntry(new DAPropertyElement(DAPropertyIds.ScanRate,
                    VarTypes.R4, "Server Scan Rate"));
                yield return new DAPropertyCatalogEntry(new DAPropertyElement(DAPropertyIds.EUType,
                    VarTypes.I4, "Item EU Type"));

                //yield return new DAPropertyCatalogEntry(new DAPropertyElement(DAPropertyIds.HighEU, VarTypes.R8, "High EU"));
                //yield return new DAPropertyCatalogEntry(new DAPropertyElement(DAPropertyIds.LowEU, VarTypes.R8, "Low EU"));

                // TODO: have more
            }
        }

        #endregion



        #region Public Properties

        [NotNull]
        public ServerDescriptorsInfo ServerDescriptors { get; }

        public override IEnumerable<ServerDescriptor> AllServerDescriptors
        {
            get
            {
                yield return ServerDescriptors.WithClsId;
                yield return ServerDescriptors.WithProgId;
                yield return ServerDescriptors.WithVersionIndependentProgId;
            }
        }

        #endregion
    }
}
