﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.AlarmsAndEvents;
using OpcLabs.EasyOpcLiveTest.Legacy.Environment.OpcKitServer;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.Legacy.AlarmsAndEvents
{
    public class AEConditionStateTest
    {

        [TestCategory("BinarySerialization")]
        [TestCategory("Live")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestMethod]
        public void BinarySerializationTestLive()
        {
            Tests.BinarySerializationTest(CreateSerializationTargetLive());
        }

        [TestCategory("Live")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTestLive()
        {
            Tests.XmlSerializationTest(CreateSerializationTargetLive());
        }

        [NotNull]
        public AEConditionState CreateSerializationTargetLive()
        {
            return EasyAEClient.SharedInstance.GetConditionState("", KitEventServer.ProgId,
                "Simulation.ConditionState1", "Simulated");
        }
    }
}
