﻿using System;

using JetBrains.Annotations;
using OpcLabs.BaseLib.Diagnostics;
using OpcLabs.EasyOpc.UA.LiveMapping;

namespace OpcLabs.EasyOpcLiveTest.UA.Environment.UASampleServer
{
    [CLSCompliant(false)]
#pragma warning disable 3021
    public class StaticNode : UAMappedNode
#pragma warning restore 3021
    {
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2214:DoNotCallOverridableMethodsInConstructors")]    // caused by Code Contracts
        public StaticNode()
        {
            UserScalar = new UserScalarNode();
        }

        [NotNull]
        [UANode]
        public UserScalarNode UserScalar { get; set; }  // non-nullness by invariant

        [UsedImplicitly]
        private void ObjectInvariant()
        {
            // Auto-implemented properties
            Check.Invariant(UserScalar != null);
        }
    }
}
