﻿using System;
using System.ComponentModel;

using System.Runtime.CompilerServices;
using OpcLabs.EasyOpc.UA.LiveMapping;

namespace OpcLabs.EasyOpcLiveTest.UA.Environment.UASampleServer
{
    [CLSCompliant(false)]
#pragma warning disable 3021
    public class UserScalarNode
#pragma warning restore 3021
        : UAMappedNode
        , INotifyPropertyChanged
    {
        private int _int32Value;

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2214:DoNotCallOverridableMethodsInConstructors")]    // caused by Code Contracts
        public UserScalarNode()
        {
        }

        [UANode, UAData]
        public virtual Int32 Int32Value
        {
            get => _int32Value;
            set
            {
                if (value == _int32Value) return;
                _int32Value = value;
                OnPropertyChanged();
            }
        }

        /// <inheritdoc cref="INotifyPropertyChanged.PropertyChanged"/>
        public event PropertyChangedEventHandler PropertyChanged;

        //[NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
