﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace OpcLabs.OpcInteroperabilityTest.Legacy.UA
{
    // ReSharper disable once InconsistentNaming
    public partial class EasyUAClientTest_IopWS201611
    {
        [NotNull]
        // ReSharper disable InconsistentNaming
        static private UAInteroperabilityWorkshopParameters Parameters_BeckhoffAutomation_TF6100
        // ReSharper restore InconsistentNaming
        {
            get
            {
                var parameters = new UAInteroperabilityWorkshopParameters
                {
                    ArrayReadableNode = "nsu=urn:CX-22946A:BeckhoffAutomation:Ua:Plc851;s=GVL_static_.stat_1dim_I4",
                    ArrayWriteableNode = "nsu=urn:CX-22946A:BeckhoffAutomation:Ua:Plc851;s=GVL_static_.stat_1dim_I4",
                    DynamicNode1 = "nsu=urn:CX-22946A:BeckhoffAutomation:Ua:Plc851;s=GVL_dynamic_.dyn_scalar_R4",
                    DynamicNode2 = "nsu=urn:CX-22946A:BeckhoffAutomation:Ua:Plc851;s=GVL_dynamic_.dyn_scalar_R8",
                    //HttpsEndpointUrlString = "",
                    NodeForDeadband = "nsu=urn:CX-22946A:BeckhoffAutomation:Ua:Plc851;s=GVL_dynamic_.dyn_scalar_R8",
                    Password = "1",
                    StaticNode = "nsu=urn:CX-22946A:BeckhoffAutomation:Ua:Plc851;s=GVL_static_.stat_scalar_I4",
                    UATcpEndpointUrlString = "opc.tcp://CX-22946A:4840",
                    UserName = "user1",
                    WriteableNode = "nsu=urn:CX-22946A:BeckhoffAutomation:Ua:Plc851;s=GVL_static_.stat_scalar_I2",
                };
                return parameters;
            }
        }

        [NotNull]
        // ReSharper disable InconsistentNaming
        static private UAInteroperabilityWorkshopParameters Parameters_BeckhoffAutomation_TF6100_2
        // ReSharper restore InconsistentNaming
        {
            get
            {
                var parameters = new UAInteroperabilityWorkshopParameters
                {
                    ArrayReadableNode = "nsu=urn:OPCUAPC:BeckhoffAutomation:Ua:Plc851;s=GVL_static_.stat_1dim_I4",
                    ArrayWriteableNode = "nsu=urn:OPCUAPC:BeckhoffAutomation:Ua:Plc851;s=GVL_static_.stat_1dim_I4",
                    DynamicNode1 = "nsu=urn:OPCUAPC:BeckhoffAutomation:Ua:Plc851;s=GVL_dynamic_.dyn_scalar_R4",
                    DynamicNode2 = "nsu=urn:OPCUAPC:BeckhoffAutomation:Ua:Plc851;s=GVL_dynamic_.dyn_scalar_R8",
                    //HttpsEndpointUrlString = "",
                    NodeForDeadband = "nsu=urn:OPCUAPC:BeckhoffAutomation:Ua:Plc851;s=GVL_dynamic_.dyn_scalar_R8",
                    Password = "1",
                    StaticNode = "nsu=urn:OPCUAPC:BeckhoffAutomation:Ua:Plc851;s=GVL_static_.stat_scalar_I4",
                    UATcpEndpointUrlString = "opc.tcp://10.10.100.131:4840",
                    UserName = "user1",
                    WriteableNode = "nsu=urn:OPCUAPC:BeckhoffAutomation:Ua:Plc851;s=GVL_static_.stat_scalar_I2",
                };
                return parameters;
            }
        }

        [NotNull]
        // ReSharper disable InconsistentNaming
        static private UAInteroperabilityWorkshopParameters Parameters_DieEntwicklerElektronik_SitopPsu8600
            // ReSharper restore InconsistentNaming
        {
            get
            {
                var parameters = new UAInteroperabilityWorkshopParameters
                {
                    AlwaysUseUserNameAndPassword = true,
                    Password = "test",
                    UATcpEndpointUrlString = "opc.tcp://10.10.107.2:4840",
                    UserName = "test",
                };
                return parameters;
            }
        }

        [NotNull]
        // ReSharper disable InconsistentNaming
        static private UAInteroperabilityWorkshopParameters Parameters_FraunhoferIosb_SecurePlugAndWorkUAServer
            // ReSharper restore InconsistentNaming
        {
            get
            {
                var parameters = new UAInteroperabilityWorkshopParameters
                {
                    AlwaysUseUserNameAndPassword = true,
                    DynamicNode1 = "nsu=http://www.iosb.fraunhofer.de/I4.0Fabrik mit Werten.aml;ns=4;i=31",
                    DynamicNode2 = "nsu=http://www.iosb.fraunhofer.de/I4.0Fabrik mit Werten.aml;ns=4;i=2111",
                    Password = "Nbg.0815",
                    //Pingable = false,
                    SamplingInterval2 = 10000,
                    StaticNode = "nsu=http://www.iosb.fraunhofer.de/I4.0Fabrik mit Werten.aml;ns=4;i=77",
                    //UATcpEndpointUrlString = "opc.tcp://10.10.102.1:51400",
                    UATcpEndpointUrlString = "opc.tcp://ilt652:51400",
                    UserName = "iop",
                };
                return parameters;
            }
        }

        [NotNull]
        // ReSharper disable once InconsistentNaming
        static private UAInteroperabilityWorkshopParameters Parameters_GeneralElectric_Cimplicity
        {
            get
            {
                var parameters = new UAInteroperabilityWorkshopParameters
                {
                    AlwaysUseUserNameAndPassword = true,
                    ArrayReadableNode = "ns=3;s=ARRAY.INT.1.READ.Value",
                    ArrayWriteableNode = "ns=3;s=ARRAY.INT.1.READ.Value",
                    DynamicNode1 = "ns=3;s=DYNAMIC.DINT.Value",
                    DynamicNode2 = "ns=3;s=DYNAMIC.REAL.Value",
                    //HttpsEndpointUrlString = "",
                    NodeForDeadband = "ns=3;s=DYNAMIC.REAL.Value",
                    Password = "SmokeTest",
                    //Pingable = false,
                    StaticNode = "ns=3;s=SINT.0.READ.Value",
                    UATcpEndpointUrlString = "opc.tcp://GE-LAPTOP:5000",    // F0:1F:AF:3B:A3:C4, 10.10.102.66, fe80::7999:cca9:eebd:d7f2
                    UserName = "GEFTEST",
                    //WriteableNode = "",
                };
                return parameters;
            }
        }

        [NotNull]
        // ReSharper disable InconsistentNaming
        static private UAInteroperabilityWorkshopParameters Parameters_Hilscher_Micro
            // ReSharper restore InconsistentNaming
        {
            get
            {
                var parameters = new UAInteroperabilityWorkshopParameters
                {
                    ArrayReadableNode = "",
                    ArrayWriteableNode = "",
                    DynamicNode1 = "nsu=http://www.exampleCustomer.com;ns=3;i=1879048251",  // Integer16_Json
                    DynamicNode2 = "nsu=http://www.exampleCustomer.com;ns=3;i=1879048251",    // Integer16_Json
                    UATcpEndpointUrlString = "opc.tcp://10.10.106.65:4840",
                    UseIsolatedClient = false,
                    UserName = "admin",
                    Password = "admintest",
                    StaticNode = "nsu=http://www.exampleCustomer.com;ns=3;i=1879048320", // Integer16
                    WriteableNode = "nsu=http://www.exampleCustomer.com;ns=3;i=1879048320", // Integer16
                };
                return parameters;
            }
        }

        [NotNull]
        // ReSharper disable InconsistentNaming
        static private UAInteroperabilityWorkshopParameters Parameters_Hilscher_Nano
            // ReSharper restore InconsistentNaming
        {
            get
            {
                var parameters = new UAInteroperabilityWorkshopParameters
                {
                    ArrayReadableNode = "",
                    ArrayWriteableNode = "",
                    DynamicNode1 = "nsu=http://www.exampleCustomer.com;ns=3;i=1879048251",  // Integer16_Json
                    DynamicNode2 = "nsu=http://www.exampleCustomer.com;ns=3;i=1879048251",    // Integer16_Json
                    UATcpEndpointUrlString = "opc.tcp://10.10.106.67:4840",
                    UseIsolatedClient = false,
                    UserName = "admin",
                    Password = "admintest",
                    StaticNode = "nsu=http://www.exampleCustomer.com;ns=3;i=1879048320", // Integer16
                    WriteableNode = "nsu=http://www.exampleCustomer.com;ns=3;i=1879048320", // Integer16
                };
                return parameters;
            }
        }

        [NotNull]
        // ReSharper disable InconsistentNaming
        static private UAInteroperabilityWorkshopParameters Parameters_InductiveAutomation_EclipseMilo
            // ReSharper restore InconsistentNaming
        {
            get
            {
                var parameters = new UAInteroperabilityWorkshopParameters
                {
                    ArrayReadableNode = "nsu=urn:eclipse:milo:hello-world;ns=2;s=HelloWorld/ArrayTypes/Int16Array",
                    ArrayWriteableNode = "nsu=urn:eclipse:milo:hello-world;ns=2;s=HelloWorld/ArrayTypes/Int16Array",
                    DynamicNode1 = "nsu=urn:eclipse:milo:hello-world;ns=2;s=HelloWorld/Dynamic/Double",
                    DynamicNode2 = "nsu=urn:eclipse:milo:hello-world;ns=2;s=HelloWorld/Dynamic/Int32",
                    NodeForDeadband = "nsu=urn:eclipse:milo:hello-world;ns=2;s=HelloWorld/Dynamic/Double",
                    UATcpEndpointUrlString = "opc.tcp://10.10.104.1:12686/example",
                    UserName = "user",
                    Password = "password1",
                    StaticNode = "nsu=urn:eclipse:milo:hello-world;ns=2;s=HelloWorld/ScalarTypes/Double"
                };
                return parameters;
            }
        }

        [NotNull]
        // ReSharper disable InconsistentNaming
        static private UAInteroperabilityWorkshopParameters Parameters_KepwareTechnologies_KepServerEX6
            // ReSharper restore InconsistentNaming
        {
            get
            {
                var parameters = new UAInteroperabilityWorkshopParameters
                {
                    ArrayReadableNode = "nsu=KEPServerEX;ns=2;s=Simulator.READONLY.16BIT.SHORTARRAY0",
                    DynamicNode1 = "nsu=KEPServerEX;ns=2;s=Simulator.READONLY.16BIT.SHORT0",
                    DynamicNode2 = "nsu=KEPServerEX;ns=2;s=Simulator.READONLY.32BIT.DWORD0",
                    NodeForDeadband = "nsu=KEPServerEX;ns=2;s=Simulator.READONLY.64BIT.DOUBLE0",
                    UATcpEndpointUrlString = "opc.tcp://kepiopserver:49320",
                    UserName = "user1",
                    Password = "password1",
                    StaticNode = "nsu=KEPServerEX;ns=2;s=Simulator.READWRITE.64BIT.DOUBLE0"
                };
                return parameters;
            }
        }

        [NotNull]
        // ReSharper disable InconsistentNaming
        static private UAInteroperabilityWorkshopParameters Parameters_Microsoft_NetStandardLibraryServer
            // ReSharper restore InconsistentNaming
        {
            get
            {
                var parameters = new UAInteroperabilityWorkshopParameters
                {
                    ArrayReadableNode = "nsu=http://test.org/UA/Data/;ns=2;i=10466",
                    //ArrayWriteableNode = "nsu=http://test.org/UA/Data/;ns=2;i=10466", // Int16[]
                    ArrayWriteableNode = "nsu=http://test.org/UA/Data/;ns=2;i=10468",   // Int32[]
                    DynamicNode1 = "nsu=http://test.org/UA/Data/;ns=2;i=11182",
                    DynamicNode2 = "nsu=http://test.org/UA/Data/;ns=2;i=11194",
                    NodeForDeadband = "nsu=http://test.org/UA/Data/;ns=2;i=11218",
                    UATcpEndpointUrlString = "opc.tcp://10.10.102.194:51210",
                    UserName = "user1",
                    Password = "password1",
                    StaticNode = "nsu=http://test.org/UA/Data/;ns=2;i=10387 ",
                    WriteableNode = "nsu=http://test.org/UA/Data/;ns=2;i=10389",
                };
                return parameters;
            }
        }

        [NotNull]
        // ReSharper disable InconsistentNaming
        static private UAInteroperabilityWorkshopParameters Parameters_Tani_PlcEngineRaspberry
            // ReSharper restore InconsistentNaming
        {
            get
            {
                var parameters = new UAInteroperabilityWorkshopParameters
                {
                    //ArrayReadableNode = "",
                    //ArrayWriteableNode = "",
                    //DynamicNode1 = "",
                    //DynamicNode2 = "",
                    UATcpEndpointUrlString = "opc.tcp://10.10.105.130:4840/",
                    //UseIsolatedClient = false,
                    UserName = "user",
                    Password = "pwd",
                    //StaticNode = "",
                    //WriteableNode = "",
                };
                return parameters;
            }
        }

        [NotNull]
        // ReSharper disable once InconsistentNaming
        static private UAInteroperabilityWorkshopParameters Parameters_UnifiedAutomation_AnsiCSdk
        {
            get
            {
                var parameters = new UAInteroperabilityWorkshopParameters
                {
                    //ArrayReadableNode = "",
                    //ArrayWriteableNode = "",
                    DynamicNode1 = "nsu=http://www.unifiedautomation.com/DemoServer/;ns=2;s=Demo.Dynamic.Scalar.Int32",
                    DynamicNode2 = "nsu=http://www.unifiedautomation.com/DemoServer/;ns=2;s=Demo.Dynamic.Scalar.Int64",
                    HttpsEndpointUrlString = "https://lt-mezhanne2:48021",
                    NodeForDeadband =
                        "nsu=http://www.unifiedautomation.com/DemoServer/;ns=2;s=Demo.Dynamic.Scalar.Float",
                    Password = "master",
                    StaticNode = "nsu=http://www.unifiedautomation.com/DemoServer/;ns=2;s=Demo.Static.Scalar.Byte",
                    UATcpEndpointUrlString = "opc.tcp://lt-mezhanne2:48020",
                    //UATcpEndpointUrlString = "opc.tcp://10.10.101.66:48020",
                    UserName = "john",
                    WriteableNode = "nsu=http://www.unifiedautomation.com/DemoServer/;ns=2;s=Demo.Static.Scalar.Int16",
                };
                return parameters;
            }
        }

        [NotNull]
        // ReSharper disable once InconsistentNaming
        static private UAInteroperabilityWorkshopParameters Parameters_UnifiedAutomation_HighPerformanceSdk
        {
            get
            {
                var parameters = new UAInteroperabilityWorkshopParameters
                {
                    //ArrayReadableNode = "",
                    //ArrayWriteableNode = "",
                    DynamicNode1 = "nsu=http://www.unifiedautomation.com/DemoServer/;ns=2;s=Demo.Dynamic.Scalar.Int32",
                    DynamicNode2 = "nsu=http://www.unifiedautomation.com/DemoServer/;ns=2;s=Demo.Dynamic.Scalar.Int64",
                    //HttpsEndpointUrlString = "",
                    NodeForDeadband = "nsu=http://www.unifiedautomation.com/DemoServer/;ns=2;s=Demo.Dynamic.Scalar.Float",
                    Password = "test",
                    StaticNode = "nsu=http://www.unifiedautomation.com/DemoServer/;ns=2;s=Demo.Static.Scalar.Byte",
                    UATcpEndpointUrlString = "opc.tcp://10.10.101.67:4840",
                    UseIsolatedClient = false,  // does not handle more than 10 open connections by default
                    UserName = "test",
                    WriteableNode = "nsu=http://www.unifiedautomation.com/DemoServer/;ns=2;s=Demo.Static.Scalar.Int16",
                };
                return parameters;
            }
        }
    }
}
