﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class HmsIndustrialNetworks_AnybusXGateway_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[] { "" };

        public override IEnumerable<UANodeDescriptor> ArrayWriteableNodes => new UANodeDescriptor[] { "" };

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "",
            ""
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://10.10.102.3:4840" };

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test04_ActivateSession_UserIdentityAnonymous),
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),
            nameof(Group003_AttributeServices_Test06_Write_Value),
            nameof(Group003_AttributeServices_Test07_Write_Array_IndexRange),
            nameof(Group008_Eventing_Test04_EventNodes_Browse),
            nameof(Group011_AlarmCondition_Test01_Browse_Types),
            nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256)
        });

        public override string Password => "pass1";

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[] { "" };

        public override string UserName => "testuser1";

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[] { "" };
    }
}
