﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class Sterfive_NodeOpcuaSdk_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[] { "ns=7;s=Static_Scalar_Large_Array_Int64" };

        public override IEnumerable<UANodeDescriptor> ArrayWriteableNodes => new UANodeDescriptor[] { "ns=7;s=Static_Array_Byte" };

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "ns=7;s=Scalar_Simulation_Double",
            "ns=7;s=Scalar_Simulation_Float"
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://node-opcua.iop.virtual.opcfoundation.org:26543" };

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new string[]
        {
            //nameof(Group001_Session_Test02_CreateSession_UaTcp_Basic128Rsa15),
            //nameof(Group001_Session_Test08_CreateSession_InstanceCertificate),
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group001_Session_Test12_CreateSession_UaTcp_Aes128_Sha256_RsaOaep),
            nameof(Group001_Session_Test13_CreateSession_UaTcp_Aes256_Sha256_RsaPss),
            nameof(Group102_Session2_Test01_CreateSession_UaTcp_Basic256),
            nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256)
        });

        public override string Password => "password1";

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[]
        {
            "ns=7;s=Static_Scalar_Double",
            "ns=7;s=Static_Scalar_Float"
        };

        public override string UserName => "user1";

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[]
        {
            "ns=7;s=Static_Scalar_Double",
            "ns=7;s=Static_Scalar_Float"
        };
    }
}
