﻿
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.Engine;
using OpcLabs.EasyOpcLiveTest.UA;
using OpcLabs.UnitTestLib;

namespace OpcLabs.OpcInteroperabilityTest.UA
{
    partial class UAInteroperabilityWorkshopTest
    {
        #region Test Methods

        [TestMethod]
        public void Group102_Session2_Header____________________()
        {
        }

        [TestMethod]
        public void Group102_Session2_Test01_CreateSession_UaTcp_Basic256()
        {
            TestSection.Arrange();
            PrecheckTestMethod();
            UAEndpointDescriptor endpointDescriptorUATcp = ConfiguredEndpointDescriptorUATcp;
            Assert.IsNotNull(endpointDescriptorUATcp);
            if (!UALiveTestEnvironment.IsSupportedOptimistic(endpointDescriptorUATcp))
                ClientNotSupported();
            var endpointDescriptor = new UAEndpointDescriptor(endpointDescriptorUATcp)
            {
                EndpointSelectionPolicy = new UAEndpointSelectionPolicy { SecurityPolicyUriString = UASecurityPolicyUriStrings.Basic256 }
            };

            TestSection.Act();
            using (var client = new EasyUAClient { Isolated = true })
                CreateSession(client, endpointDescriptor);
        }

        [TestMethod]
        public void Group102_Session2_Test02_CreateSession_UaTcp_Basic256Sha256()
        {
            TestSection.Arrange();
            PrecheckTestMethod();
            UAEndpointDescriptor endpointDescriptorUATcp = ConfiguredEndpointDescriptorUATcp;
            Assert.IsNotNull(endpointDescriptorUATcp);
            if (!UALiveTestEnvironment.IsSupportedOptimistic(endpointDescriptorUATcp))
                ClientNotSupported();
            var endpointDescriptor = new UAEndpointDescriptor(endpointDescriptorUATcp)
            {
                EndpointSelectionPolicy = new UAEndpointSelectionPolicy { SecurityPolicyUriString = UASecurityPolicyUriStrings.Basic256Sha256 }
            };

            TestSection.Act();
            using (var client = new EasyUAClient { Isolated = true })
                CreateSession(client, endpointDescriptor);
        }

        [TestMethod]
        public void Group102_Session2_Test03_CreateSession_Https_Basic256Sha256()
        {
            TestSection.Arrange();
            PrecheckTestMethod();
            UAEndpointDescriptor endpointDescriptorHttps = EndpointDescriptorHttps;
            Assert.IsNotNull(endpointDescriptorHttps);
            if (!UALiveTestEnvironment.IsSupportedOptimistic(endpointDescriptorHttps))
                ClientNotSupported();
            var endpointDescriptor = new UAEndpointDescriptor(endpointDescriptorHttps)
            {
                EndpointSelectionPolicy = new UAEndpointSelectionPolicy { SecurityPolicyUriString = UASecurityPolicyUriStrings.Basic256Sha256 }
            };

            TestSection.Act();
            using (var client = new EasyUAClient { Isolated = true })
                CreateSession(client, endpointDescriptor);
        }

        #endregion
    }
}
